package com.adc.da.main;

import com.codahale.metrics.ConsoleReporter;
import com.codahale.metrics.CsvReporter;

import java.util.Arrays;
import java.util.List;
import java.util.concurrent.TimeUnit;

import org.dozer.DozerBeanMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.scheduling.annotation.EnableAsync;

@SpringBootApplication
@ComponentScan("com.adc.da")
@ServletComponentScan
@EnableAsync
public class AdcDaApplication {

    private static final Logger logger = LoggerFactory.getLogger(AdcDaApplication.class);

    public static void main(String[] args) {
        ApplicationContext applicationContext = SpringApplication.run(AdcDaApplication.class, args);

        // 启动Metrics 性能监控报表
//        CsvReporter reporter = applicationContext.getBean(CsvReporter.class);
//        reporter.start(1, TimeUnit.MINUTES);
    }

    @Bean(name = "org.dozer.Mapper")
    public DozerBeanMapper dozer() {
        List<String> mappingFiles = Arrays.asList("dozer/dozer-mappings-sys.xml");
        DozerBeanMapper dozerBean = new DozerBeanMapper();
        dozerBean.setMappingFiles(mappingFiles);
        return dozerBean;
    }
}
