package com.adc.da.main.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;

@Configuration
public class InterceptorConfig extends WebMvcConfigurationSupport {


    @Override
    protected void addInterceptors(InterceptorRegistry registry) {
        String[] excludePath = {"/api/login/**",//登录
                "/api/news/newsIndexGroupByType",//首页资讯
                "/api/report/**",//首页资讯
                "/api/param/findBrandFuelPc",//获取pc
                "/api/news/newslistIndex",//首页资讯
                "/api/workmanage/workmanageIndex",//首页办事指南
                "/api/standardmanage/findWorkListIndex",//首页标准预告
                "/api/standardmanage/standardmanageList",//老版首页接口
                "/api/qa/list_index",//老版首页接口
                "/api/qa/findCYzxBaseDataEOServiceImpllassicQList",//老版首页接口
                "/api/workmanage/workmanageList",//老版首页接口
                "/swagger-resources/**",
                "/swagger-ui.html/**"};
        registry.addInterceptor(
                new AdminInterceptor())
                .addPathPatterns("/**")
                .excludePathPatterns(excludePath);
    }

    @Override
    protected void addResourceHandlers(ResourceHandlerRegistry registry) {
        registry.addResourceHandler("swagger-ui.html")
                .addResourceLocations("classpath:/META-INF/resources/");
        registry.addResourceHandler("/webjars/**")
                .addResourceLocations("classpath:/META-INF/resources/webjars/");
    }
}
